<?php
	
//------------------------------------------------------------------------
// This script is a part of ABC Mail Manager
//
// Version: 2.5
// Homepage: www.zakkis.ca
// Copyright (c) 2002-2003 Zakkis Technology, Inc.
// All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------
	
/**
* Input parameters for this script (they should be defined as variables at script scope):
*	$target - link to self. You can include this hp script to custom designed page
*			define $target and all Prev,Next and page-number links will follow to this page
*			$ctx and $page parameters will be passed using GET semantics.
*	$ctx - Page context. There are two different context for mail archive browser:
*				0 - Letter index
*				1 - Letter browser
*		when next, prev or page number link is formatted the context is equal to zero.
*		In case of formatting letter browser link, the context is equal to 1.
*		On the $target side user can determine by passed $ctx which page should be included.
*			mail_acrhive.php or archive_letter.php.
*	$page [optional] - Page number to browse using this script.
*
* This script is protected by password. To make this script free-launched simply include init.php
* and define variable $Correct of any type with any value at global scope.
*/

	include ('class/ArchiveIndex.class.inc');
	
	CheckCallIsCorrect();
	
	global $HTTP_GET_VARS, $HTTP_POST_VARS, $active_folder;
	
	if ( !isset ( $_GET['select'] ) )
		$active_folder = $_COOKIE['folder'];
	else 	$active_folder = $_GET['select'];
	
		
	//
	// Load archive index
	
	$index = new ArchiveIndex( false, $active_folder ); // Open index in reverse order
	
	//
	// Perform deleting (if any)
	
	$del_ids = array();
	if( !IsDemo() )
	{
		foreach( $HTTP_POST_VARS as $key => $var )
		{
			if( strstr( $key, 'Del' ) == $key )
			{
				$id = substr( $key, 3 );
				settype( $id, 'integer' );
				$del_ids[] = $id;
			}
		}
	}
	else
	{
		print "<P align=center class=varningText>Deletion from archive is disabled in the demo version.</P>";
	}
	
	
	if( count($del_ids ) > 0 )
	{
		sort( $del_ids );
		
		for( $i = count($del_ids ); --$i >= 0; )
			$index->DeleteLetter( $del_ids[ $i ] );
			
		$index->data = array_reverse( $index->data );
		$index->Write();
		
		unset( $index );
		$index = new ArchiveIndex( true, $active_folder ); // Re-open index in reverse order
	}

	//
	// Adjust indexes
	
	$page_size = 10;
	$page = 0;
	
	if( isset( $HTTP_GET_VARS['page'] ) )
		$page = $HTTP_GET_VARS['page'];
	elseif(isset( $HTTP_POST_VARS['page'] ) )
		$page = $HTTP_POST_VARS['page'];
		
	if( $page * $page_size >= $index->GetCount( $active_folder ) )
		$page = $index->GetCount( $active_folder ) / $page_size;
		
	$start = $page * $page_size; 		// inclusive
	$end = ( $page + 1 ) * $page_size; 	// non-inclusize
	
	$page_count = (int) ($index->GetCount( $active_folder ) / $page_size);
	
	if( $index->GetCount( $active_folder ) % $page_size > 0 )
		$page_count++;
		
	if( $end >= $index->GetCount( $active_folder ) )
		$end = $index->GetCount( $active_folder );
		
	// Configure target link
	$letter_target = $target . "&ctx=1";
	$target .= "&ctx=$ctx";
?>
	
<form name="edit_form" method="post" action="<?=$target;?>">
	<input type=hidden name="ctx" value="0">
	<table width="90%" border=0 cellpadding="5" cellspacing="0" class="bodyText">
	<tr><td colspan=6 bgcolor="#e0e0e0" height="1"></td></tr>

<?php
	$count = $index->GetCount($active_folder);
	
	if( $count == 0 )
	{
		if ( !empty ( $active_folder ) )
			print "<tr><td colspan=6 align=center valign=top class=bodyText>No messages in \"<b>$active_folder</b>\" maillist archive</td></tr>";
		else	print "<tr><td colspan=6 align=center valign=top class=bodyText>No active maillist selected</td></tr>";
	}
	else
	{
		$num = 0;
		
		for( $i = $start; $i <= $end; $i++ )
		{
			$letter = $index->Get( $i );
			
			$letter->folder;
			
			if ( $active_folder == $letter->folder ) {
			
				$num++;
				
				$file_alt = "No attachment";
				$file_image = "images/empty.gif";	
				if( $letter->HasAttachments() )
				{
					$file_image = "images/file.gif";	
					$file_alt = "Attachment";
				}
					
				$number = $num;
				
				$send_time = date("D M j G:i:s Y", $letter->tm );
				
				$subject = htmlspecialchars( $letter->subject, ENT_QUOTES );
				
				if ( empty ( $subject ) )
					$subject = "No subject";
				
				print <<<END
				<tr>
					<td align=left valign=top width=12>
						<font class=bodyText><b>$number</b></font>
					</td>
					<td width=20>
						<img alt="Letter" src="images/mail.gif">
					</td>
					<td width=20>
						<img alt="$file_alt" src="$file_image">
					</td>
					<td width=180>
						<font class=BodyText>$send_time</font>
					</td>
					<td width=40>
						<input type=checkbox name=Del$i>
					</td>
					<td width="*">
						<a href="$letter_target&id=$i">$subject</a>
					</td>
				</tr>
		
END;
			}


		}
		
	if( $page_count > 1 )
	{
?>

	<tr><td colspan=6 bgcolor="#e0e0e0" height="1"></td></tr>

	<tr>
		<td>
<?php
	//
	// Print prev link --------------------------------
	
	if( $page > 0 )
	{
		$prev = $page - 1;
		print "<a href=\"$target&page=$prev\">&lt;&lt;</a>&nbsp";
	}
	else
		print "&lt;&lt;&nbsp";

	//
	// Print page links --------------------------------
	
	for( $i = 0; $i < $page_count; $i++ )
	{
		if( $i == $page )
			print "<b>$page</b>&nbsp";
		else
			print "<a href=\"$target&page=$i\">$i</a>&nbsp";
	}

	//
	// Print next link --------------------------------
	
	if( $page != $page_count - 1 )
	{
		$next = $page + 1;
		print "<a href=\"$target&page=$next\">&gt;&gt;</a>&nbsp";
	}
	else
		print "&gt;&gt;&nbsp";
?>
		</td>
	</tr>
	
<?php
		} // if( $page_count > 1 )
?>
	
	<tr><td colspan=6 bgcolor="#e0e0e0" height="1"></td></tr>
	
	<tr>
		<td colspan=6 height="1" align=right>
			<input type=submit name=submit value="Delete selected">
		</td>
	</tr>
	
	<tr><td colspan=6 bgcolor="#e0e0e0" height="1"></td></tr>
	
<?php
	} // end of else of if( $index->GetCount() == 0 )
?>

	</table>
</form>